/*
 * vms dir.c
 */

#include <linux/fs.h>
#include "vms_fs.h"
#include "vms_fs_sb.h"
#include "vms_fs_i.h"

/* XXX */
extern int vms_lookup (struct inode *, const char *, int, struct inode **);
extern int vms_bmap (struct inode *, int);
extern void vms_print_inode (struct inode *);

/*
 * this is fucking (can I say fucking in the kernel?) messy
 */
static int
vms_readdir (struct inode * inode, struct file * filp, void * dirent,
	     filldir_t filldir)
{
#define recsize (*((ushort *)de))
#define STOP	((ushort)0177777)

	int offset,fpos,block,ino,entries;
	struct super_block *s;
	struct vms_directory *vmd;
	struct vms_home_info *vhi;
	struct vms_inode_info *vii;
	struct vms_header *dhp,*dh;
	char *dirbuf[VMS_BLOCKSIZE];

	printk(". (%i) ",filp->f_pos);
        if (!inode || !inode->i_sb || !S_ISDIR(inode->i_mode))
                return -EBADF;
	s = inode->i_sb;

 	vhi = (struct vms_home_info *)s->u.generic_sbp;
	dhp = &vhi->indexh;

	vii = (struct vms_inode_info *)inode->u.generic_ip;
	dh = &vii->header;

	offset = filp->f_pos & (VMS_BLOCKSIZE-1);

	entries = 0;

	if(filp->f_pos == 0) {
		if(filldir(dirent,".",1,0,inode->i_ino) < 0) {
			return(0);
		}
		filp->f_pos++;
		entries++;
	}
	if(filp->f_pos == 1) {
		if(filldir(dirent,"..",2,1,VMS_ROOT_INO) < 0) {
			return(0);
		}
		filp->f_pos++;
		entries++;
	}

	fpos = filp->f_pos - 2;
	block = fpos / VMS_BLOCKSIZE + 1;
	offset = fpos & (VMS_BLOCKSIZE-1);

	while(block <= dh->h_use) {	/* XXX is this right? */
		struct vms_dirval *dv;
		int i,nextblock;

		if(!getvb(block,dirbuf,dh,s->s_dev)) {
			return(0);
		}

		nextblock = 0;
		fpos = (block-1)*VMS_BLOCKSIZE;

		while(!nextblock) {
			vmd = (struct vms_directory *)(&((char *)dirbuf)[offset]);
			printk("0x%x[0x%x]:0x%x:0x%x {\n",dirbuf,offset,vmd,vmd->d_rbc);
			if(vmd->d_rbc == (ushort)-1) {
				block++;
				offset = 0;
				printk("whopping\n");
				continue;
				nextblock = 1;
			}

			for(i=0;i<35;i++) {
				printk("%c",((char *)vmd)[i]);
			}
			printk("\n}\n");

			dv = (struct vms_dirval *)(vmd->d_fname + vmd->d_nbc);
			ino = dv->d_fid.f_num;
			printk("%s\n",vmd->d_fname);
			if(filldir(dirent,vmd->d_fname,vmd->d_nbc,filp->f_pos,ino) < 0) {
				return(0);
			}

			offset += vmd->d_rbc+2;
			fpos += vmd->d_rbc+2;
			entries++;
/* shouldn't need this..
			if(offset >= VMS_BLOCKSIZE) {
				block++;
				offset -= VMS_BLOCKSIZE;
				nextblock = 1;
			}
*/
		}
	}

	filp->f_pos += fpos+2;
	return(entries);
}

static struct file_operations vms_dir_operations = {
	NULL,			/* lseek */
	NULL,			/* read */
	NULL,			/* write */
	vms_readdir,		/* readdir */
	NULL,			/* select */
	NULL,			/* ioctl */
	NULL,			/* mmap */
	NULL,			/* open */
	NULL,			/* release */
	file_fsync,		/* fsync */
	NULL,			/* fasync */
	NULL,			/* check_media_change */
	NULL,			/* revalidate */
};

struct inode_operations vms_dir_inode_operations = {
	&vms_dir_operations,	/* default directory file operations */
	NULL,			/* create */
	vms_lookup,		/* lookup */
	NULL,			/* link */
	NULL,			/* unlink */
	NULL,			/* symlink */
	NULL,			/* mkdir */
	NULL,			/* rmdir */
	NULL,			/* mknod */
	NULL,			/* rename */
	NULL,			/* readlink */
	NULL,			/* follow_link */
	NULL,			/* readpage */
	NULL,			/* writepage */
	NULL,			/* bmap */
	NULL,			/* truncate */
	NULL,			/* permission */
	NULL,			/* smap */
};
